﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XamDataChartStackedGridCase
{
    public class EnergyProductionDataSample : ObservableCollection<EnergyProduction>
    {
        public EnergyProductionDataSample()
        {
            this.Add(new EnergyProduction { Region = "America", Country = "Canada", Coal = 400, Oil = 100, Gas = 175, Nuclear = 225, Hydro = 350 });
            this.Add(new EnergyProduction { Region = "Asia", Country = "China", Coal = 925, Oil = 200, Gas = 350, Nuclear = 400, Hydro = 625 });
            this.Add(new EnergyProduction { Region = "Europe", Country = "Russia", Coal = 550, Oil = 200, Gas = 250, Nuclear = 475, Hydro = 425 });
            this.Add(new EnergyProduction { Region = "Asia", Country = "Australia", Coal = 450, Oil = 100, Gas = 150, Nuclear = 175, Hydro = 350 });
            this.Add(new EnergyProduction { Region = "America", Country = "United States", Coal = 800, Oil = 250, Gas = 475, Nuclear = 575, Hydro = 750 });
            this.Add(new EnergyProduction { Region = "Europe", Country = "France", Coal = 375, Oil = 150, Gas = 350, Nuclear = 275, Hydro = 325 });
        }
    } 
        
    public class EnergyProduction
    {

        public string Country { get; set; }
        public string Region { get; set; }
        public string Year { get; set; }

        // Non-Renewable Energy Sources
        private double _nuclear;
        public double Nuclear { get { return _nuclear; } set { _nuclear = value; UpdateValues(); } }

        private double _coal;
        public double Coal { get { return _coal; } set { _coal = value; UpdateValues(); } }

        private double _oil;
        public double Oil { get { return _oil; } set { _oil = value; UpdateValues(); } }

        private double _gas;
        public double Gas { get { return _gas; } set { _gas = value; UpdateValues(); } }
        // Renewable Energy Sources
        private double _hydro;
        public double Hydro { get { return _hydro; } set { _hydro = value; UpdateValues(); } }

        private double _geoThermal;
        public double GeoThermal { get { return _geoThermal; } set { _geoThermal = value; UpdateValues(); } }

        private double _solar;
        public double Solar { get { return _solar; } set { _solar = value; UpdateValues(); } }

        private double _wind;
        public double Wind { get { return _wind; } set { _wind = value; UpdateValues(); } }

        public double Total { get; set; }
        public double Renewable { get; set; }
        public double NonRenewable { get; set; }

        public void UpdateValues()
        {
            this.Renewable = Hydro + GeoThermal + Wind + Solar;
            this.NonRenewable = Coal + Oil + Gas + Nuclear;
            this.Total = this.Renewable + this.NonRenewable;
        }
    }

}
