﻿using Infragistics;
using Infragistics.Controls.Charts.VisualData;
using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace XamDataChartStackedGridCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();
        }

        private void visualDataCheckerBtn_Click(object sender, RoutedEventArgs e)
        {
            ResizeFields();   
        }

        const double plotAreaPosition = 81; //This will be the extent of the Y Axis label-settings + 6.
        private void ResizeFields()
        {
            if (xAxis != null && xAxis.RootCanvas != null)
            {
                //Point p = xAxis.RootCanvas.PointToScreen(new Point(0, 0)); //First column width should be X value...
                ChartVisualData data = chart.ExportVisualData();

                AxisVisualData axisData = data.Axes[0];

                PathVisualData tickData = axisData.TickMarks as PathVisualData;

                LineGeometryData previous = new LineGeometryData();
                double fieldWidth = 0;
                foreach (var x in tickData.Data)
                {
                    if (x is LineGeometryData)
                    {
                        LineGeometryData lgd = x as LineGeometryData;

                        if (previous != null)
                        {
                            fieldWidth = lgd.X1 - previous.X1;

                            if (fieldWidth != 0)
                            {
                                break;
                            }
                        }

                        previous = x as LineGeometryData;
                    }
                }

                if (fieldWidth != 0)
                {
                    foreach (Field field in xdg1.DefaultFieldLayout.Fields)
                    {
                        if (field.Index == 0)
                        {
                            field.Width = new FieldLength(plotAreaPosition);
                        }
                        else
                        {
                            field.Width = new FieldLength(fieldWidth);
                        }
                    }
                }
            }
        }

        private void chart_RefreshCompleted(object sender, EventArgs e)
        {
            Dispatcher.BeginInvoke(new Action(() =>
            {
                ResizeFields();
            }), DispatcherPriority.ApplicationIdle);
        }      
    }
}
