﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XamDataChartStackedGridCase
{
    public class ViewModel
    {
        public EnergyProductionDataSample ChartData { get; set; }
        public DataTable GridData { get; set; }

        public ViewModel()
        {
            ChartData = new EnergyProductionDataSample();

            List<string> cats = new List<string>() { "Coal", "Hydro", "Nuclear", "Gas", "Oil" };
            List<double> coal = ChartData.Select(e => e.Coal).ToList();
            List<double> hydro = ChartData.Select(e => e.Hydro).ToList();
            List<double> oil = ChartData.Select(e => e.Oil).ToList();
            List<double> gas = ChartData.Select(e => e.Gas).ToList();
            List<double> nuclear = ChartData.Select(e => e.Nuclear).ToList();


            GridData = new DataTable();

            GridData.Columns.Add(new DataColumn("Category", typeof(string)));
            GridData.Columns.Add(new DataColumn("Canada", typeof(double)));
            GridData.Columns.Add(new DataColumn("China", typeof(double)));
            GridData.Columns.Add(new DataColumn("Russia", typeof(double)));
            GridData.Columns.Add(new DataColumn("Australia", typeof(double)));
            GridData.Columns.Add(new DataColumn("UnitedStates", typeof(double)));
            GridData.Columns.Add(new DataColumn("France", typeof(double)));

            for(int i=0; i<cats.Count; i++)
            {
                string str = cats[i];

                DataRow row = GridData.NewRow();
                row[0] = cats[i];

                switch (str)
                {
                    case "Coal": 
                        {
                            GenerateRowData(row, coal);
                            break;
                        }
                    case "Hydro":
                        {
                            GenerateRowData(row, hydro);
                            break;
                        }
                    case "Nuclear":
                        {
                            GenerateRowData(row, nuclear);
                            break;
                        }
                    case "Gas":
                        {
                            GenerateRowData(row, gas);
                            break;
                        }
                    case "Oil":
                        {
                            GenerateRowData(row, oil);
                            break;
                        }
                }

                GridData.Rows.Add(row);
            }                     
        }

        private void GenerateRowData(DataRow row, List<double> data)
        {
            for(int i=0; i < data.Count; i++)
            {
                row[i + 1] = data[i];
            }
        }
    }
}
